#ifndef TEMPS_PRESENTER_HPP
#define TEMPS_PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class TempsView;

class TempsPresenter : public Presenter, public ModelListener
{
public:
    TempsPresenter(TempsView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    virtual ~TempsPresenter() {};

    virtual void ActualisationTemps_P();

private:
    TempsPresenter();

    TempsView& view;
};


#endif // TEMPS_PRESENTER_HPP
