#include <gui/communiquer_screen/CommuniquerView.hpp>
#ifndef SIMULATOR
	#include "stm32f7xx_hal.h"
	#include "stm32f769i_discovery.h"
   
	bool finDeTransmission = false;

	extern UART_HandleTypeDef huart6;
	extern uint8_t rx_index;
	extern uint8_t rx_data;
	extern uint8_t rx_buffer[32];
	extern Led_TypeDef led_red;
#endif

CommuniquerView::CommuniquerView()
{

}

void CommuniquerView::setupScreen()
{
    CommuniquerViewBase::setupScreen();
    #ifndef SIMULATOR
    	BSP_LED_Init(led_red);
    #endif
}

void CommuniquerView::tearDownScreen()
{
    CommuniquerViewBase::tearDownScreen();
}

void CommuniquerView::envoyer_sur_serie()
{
	#ifndef SIMULATOR
	char message[] = "Test_envoi\n";
	HAL_UART_Transmit(&huart6, (uint8_t*) message ,12, 0xFFF);
	#endif
}

#ifndef SIMULATOR
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
  if (huart->Instance == USART6)
  {
    if(rx_index == 0)
    {
      for(int i = 0; i<32; i++)
      {
        rx_buffer[i] = 0;
      }
    }
    if (rx_data != (uint8_t)'\n')
    {
      
      rx_buffer[rx_index] = rx_data;
      rx_index++;

      if (rx_index>=32)
      {
        rx_index = 0;
        finDeTransmission = true;
      }
      
    }
    else
    {
      rx_index = 0;
      finDeTransmission = true;
    }
    HAL_UART_Receive_IT(&huart6, &rx_data,1);
  }
}
#endif

void CommuniquerView::Actualiser()
{
	#ifndef SIMULATOR

	for(int i = 0; i<32; i++)
	{
		caracteresRecusBuffer[i] = rx_buffer[i];
	}
	caracteresRecus.invalidate();

	#endif
}